#!/usr/bin/perl -w
use strict;
use warnings;

my $db       = "db.fa";
my $out      = "out.fas";

my @inFileCont = <DATA>;

open(DB, "$db") or die "Cannot find the database, $db\n";
my @dbFileCont = <DB>;
close DB;

my ($ref_fasHashDB, $ref_nameArrayDB, $seqLengthDB) = &fasHashReader(\@dbFileCont);

open(OUT, ">$out");
my $count = 0;
foreach my $name (@inFileCont){
  chomp($name);
  if(my @tempNameLineDB = grep(/$name /, @$ref_nameArrayDB)){
    if(scalar(@tempNameLineDB) > 1){
      print "More than 2 records $name. Stop.\n";
      exit;      
    }
    else {
      $count++;
      my $nameLineDB = join('', @tempNameLineDB);
      print "$count. $name\n";
      print OUT "$nameLineDB\n";
      print OUT "$$ref_fasHashDB{$nameLineDB}\n";
    }
  } else {
    print "NOT FOUND $name. Stop.\n";
    exit;
  }
}
close OUT;

exit;

######################
sub turnover {
  my ($seqTO) = @_;
  $seqTO =~ s/(.{80})/$1\n/g;
  return($seqTO);
}

sub fasHashReader
{
  my $name = "";
  my $seq = "";
  my $seqLength = "";
  my $stone = 0;
  my @nameArraySR = ( );
  my %fasHashSR = ( );

  my ($inFileContSR) = @_;

  foreach my $inFileLine (@$inFileContSR) {
    chomp($inFileLine);
    if($inFileLine =~ /^>/){  
      if($stone == 0){
        $name = $inFileLine;
        $stone = 1;  
      } else {
        $fasHashSR{$name} = $seq;  
        push(@nameArraySR,$name);
        $name = "$inFileLine";
        $seq = "";
      }
    } else {
      $seq .= $inFileLine; 
    }
  }
  $fasHashSR{$name} = $seq;
  $seqLength = length($seq);
  push(@nameArraySR,$name);

  return (\%fasHashSR,\@nameArraySR,\$seqLength);

}


__END__
ENSP00000362111
ENSP00000356744
ENSP00000363115
